<!DOCTYPE html>
<html>

<head>
  <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <link rel="stylesheet" href="//cdn.datatables.net/1.13.4/css/jquery.dataTables.min.css">
  <script src="//cdn.datatables.net/1.13.4/js/jquery.dataTables.min.js"></script>

  <script>
    "use strict";
    /* Mảng userObjects là mảng chứa dữ liệu user. Từng phần tử là object
    */
    var gStudents = [
      {
        id: 2, // tự tăng
        studentCode: "1356783",
        firstname: "Ngo Van",
        lastname: "Quan",
        age: 18,
        email: "quan@gmail.com",
        studyYear: 2015
      },
      { id: 3, studentCode: "1356784", firstname: "Leo", lastname: "Thuan", age: 18, email: "thuan@gmail.com", studyYear: 2015 },
      { id: 4, studentCode: "1356785", firstname: "Windy", lastname: "Thanh", age: 18, email: "thanh@gmail.com", studyYear: 2015 },
      { id: 5, studentCode: "1356786", firstname: "Nguyen", lastname: "Thong", age: 18, email: "Thong@gmail.com", studyYear: 2015 },
      { id: 6, studentCode: "1356787", firstname: "Bao", lastname: "Quoc", age: 18, email: "Quoc@gmail.com", studyYear: 2015 },
    ];

    var gSubjects = [
      {
        id: 5, // tự tăng
        subjectCode: "MATH101",
        subjectName: "Toán cao cấp 1"
      },
      // điền thêm 04 môn học nữa
      { id: 6, subjectCode: "PHYS101", subjectName: "Vật lý cơ bản 1" },
      { id: 7, subjectCode: "CHEM101", subjectName: "Hóa học cơ bản 1" },
      { id: 8, subjectCode: "CS101", subjectName: "Lập trình căn bản" },
      { id: 9, subjectCode: "ENG101", subjectName: "Tiếng Anh căn bản" }
    ];

    var gGrades = [
      { 
        id: 2, // tự tăng 
        studentId: 2,
        subjectId: 5,
        grade: 8,
        examDate: "13/04/2021"
      },
      // điền thêm 9 kết quả thi nữa
      {
        id: 3,
        studentId: 2,
        subjectId: 6,
        grade: 7,
        examDate: "15/04/2021"
      },
      {
        id: 4,
        studentId: 2,
        subjectId: 7,
        grade: 9,
        examDate: "17/04/2021"
      },
      {
        id: 5,
        studentId: 2,
        subjectId: 8,
        grade: 6,
        examDate: "19/04/2021"
      },
      {
        id: 6,
        studentId: 2,
        subjectId: 9,
        grade: 8,
        examDate: "21/04/2021"
      },
      {
        id: 7,
        studentId: 3,
        subjectId: 5,
        grade: 9,
        examDate: "13/04/2021"
      },
      {
        id: 8,
        studentId: 3,
        subjectId: 6,
        grade: 8,
        examDate: "15/04/2021"
      },
      {
        id: 9,
        studentId: 3,
        subjectId: 7,
        grade: 7,
        examDate: "17/04/2021"
      },
      {
        id: 11,
        studentId: 3,
        subjectId: 9,
        grade: 9,
        examDate: "21/04/2021"
      },
      {
        id: 12,
        studentId: 4,
        subjectId: 5,
        grade: 7,
        examDate: "13/04/2021"
      },
    ];
    console.log("Array Studen: ");
    console.log(gStudents);
    console.log("Array Subjects: ");
    console.log(gSubjects);
    console.log("Array gGrandes: ");
    console.log(gGrades);

    var gSTT = 1;
    //REGION 2
    $(document).ready(function(){
      onPageLoading();
      //gán sự kiện cho nút filter data được ấn
      $("#btn-filter").on('click', function(){
        onBntFilterDataClick();
      })
    })
  //REGION 3
  function onPageLoading() {
      $("#history-study-table").DataTable({
        data: gGrades,
        columns: [
          { data: "id"},
          { data: "studentId"},
          { data: "subjectId"},
          { data: "grade"},
          { data: "examDate"}
        ],
        columnDefs: [ // định nghĩa lại cột
          {
            targets: 0,
            render: function (data) {
              return gSTT++;
            }
          },
          {
            targets: 1,
            render: studentIdToStudent,
          },
          {
            targets: 2,
            render: subjectIdToSubject,
          }
        ]
      });
      loadDataToStudentSelect(gStudents);
      loadDataToSubjectSelect(gSubjects);
    }
    //hàm thự hiện sự kiện nút lọc dữ liệu được click
    function onBntFilterDataClick(){
      console.log("nút được ấn");
      // khai báo biến lưu dữ liệu obj
      var vStudentObj = {
        student: "",
        subject: "",
      }
      //b1 thu thập dữ liệu
      getDataFilter(vStudentObj);
      //b2 lọc dữ liệu
      var vFilter = filterData(vStudentObj);
      console.log(vFilter);
      //b3 xử lý hiển thị
      showDataFilterTable(vFilter);
    }
  //REGION 4
    //hàm thu thập dữ liệu 
    function getDataFilter(paramData){
      paramData.student = $("#select-student").val();
      paramData.subject = $("#select-subject").val();
    }
    //hàm lọc dữ liệu
    function filterData(paramFilter){
      var vResult = [];
      vResult = gGrades.filter(function(item) {
              return (item.studentId == paramFilter.student && item.subjectId == paramFilter.subject);
            });
            return vResult;
    }
    //hàm hiển thị thông tin table đã được lọc
    function showDataFilterTable(paramData){
      gSTT = 1;
      var vTable = $("#history-study-table").DataTable();
      vTable.clear() //xóa bảng
      vTable.rows.add(paramData) // thêm dữ liệu vào bảng
      vTable.draw() //vẽ lại bảng
    }
    //hàm load dữ liệu vào table dữa vào student id
    function studentIdToStudent(paramData){
      var vStudent = "";
      for(let bI = 0; bI < gStudents.length; bI++){
        if(paramData == gStudents[bI].id){
          vStudent = (gStudents[bI].firstname+ " " + gStudents[bI].lastname);
        }
      }
      return vStudent;
    }

    function subjectIdToSubject(paramData){
      var vSubject = "";
      for(let bI = 0; bI < gSubjects.length; bI++){
        if(paramData == gSubjects[bI].id){
          vSubject = gSubjects[bI].subjectName;
        }
      }
      return vSubject;
    }
    //hàm load dữ liệu vào student select
    function loadDataToStudentSelect(paramData){
      $("#select-student").append($("<option>", {
        value: 0,
        text: "--Chọn student--",
      }));
      for(let bI = 0; bI < paramData.length; bI++){
        $("#select-student").append($("<option>", {
        value: paramData[bI].id,
        text: paramData[bI].firstname + " " + paramData[bI].lastname 
      }));
      }
    }
    //hàm load dữ liệu vào subject select
    function loadDataToSubjectSelect(paramData){
      $("#select-subject").append($("<option>", {
        value: 0,
        text: "--chọn subject--",
      }));
      for(let bI = 0; bI < paramData.length; bI++){
        $("#select-subject").append($("<option>", {
          value: paramData[bI].id,
          text: paramData[bI].subjectName
        }))
      }
    }
  </script>
</head>
<body>
  <div class="container">
    <div class="text-center mb-2 mt-2">
      <h2>F200 - LỊCH SỬ HỌC TẬP</h2>
    </div>
    <div class="container jumbotron">
      <div><h3>Thông tin Student: </h3></div>
      <div class="row form-group d-flex mt-4">
        <div class="col-sm-5">
          <div class="row">
            <div class="col-sm-4">
              <label for="">Student</label>
            </div>
            <div class="col-sm-8">
              <select class="form-control" id="select-student">

              </select>
            </div>
          </div>
        </div>
    
        <div class="col-sm-5">
          <div class="row">
            <div class="col-sm-4">
              <label for="">Subject</label>
            </div>
            <div class="col-sm-8">
              <select name="" id="select-subject" class="form-control">
                
              </select>
            </div>
          </div>
        </div>
        
        <div class="col-sm-2">
          <button class="btn btn-success" id="btn-filter">Lọc chi tiết</button>
        </div>

      </div>
    </div>
  </div>

  <div class="container">
    <table class="table table-bordered table-striped table-hover" id="history-study-table">
      <thead>
        <tr>
          <th>STT</th>
          <th>Student</th>
          <th>Môn học</th>
          <th>Điểm</th>
          <th>Ngày thi</th>
        </tr>
      </thead>
    </table>
  </div>
</body>

</html>